<?php
#
# Avatar Modification by aldo.
#
# This modifications point is to serve up avatars
# while using the least amount of resources
#

if(!defined('SMF'))
  die;

# We gotta do a bit here. Since SMF uses ; instead of &
# its a bit, different XD
$temp = explode(';', $_SERVER['QUERY_STRING']);
foreach($temp as $tmp)
  if(substr($tmp, 0, 6) == 'attach')
  {
    @list(, $_GET['attach']) = explode('=', $tmp);
    break;
  }

# Don't be a waste of our time!
if(empty($_GET['attach']) || (string)$_GET['attach'] != (string)(int)$_GET['attach'])
  die('Invalid avatar request.');

# We need two things for SMF 1.1.9 (2.0, only one :/)
require($sourcedir. '/Load.php');
require($sourcedir. '/Subs.php');

if(!empty($maintenance) && $maintenance == 2)
  die;

# Load the database.
if(empty($db_persist))
  $db_connection = @mysql_connect($db_server, $db_user, $db_passwd);
else
  $db_connection = @mysql_pconnect($db_server, $db_user, $db_passwd);

# Fail..?
if(!$db_connection || !@mysql_select_db($db_name, $db_connection))
  die;

# Settings...
reloadSettings();

# Do some other *things*
if(!empty($modSettings['enableCompressedOutput']) && !headers_sent() && ob_get_length() == 0)
{
  if(@ini_get('zlib.output_compression') == '1' || @ini_get('output_handler') == 'ob_gzhandler' || @version_compare(PHP_VERSION, '4.2.0') == -1)
    $modSettings['enableCompressedOutput'] = '0';
	else
    ob_start('ob_gzhandler');
}

# Gotta do it still?
if(empty($modSettings['enableCompressedOutput']))
  ob_start();

# What is the attachment number?
$id_attach = (int)$_GET['attach'];

# By any chance, cached? (This is less likely in SMF 1.1.x)
if(($cache = cache_get_data('avatar_lookup_id-'. $id_attach)) != null)
{
  # :P
  $file = $cache;
}
else
{
  # Sadly, no...
  # It is database querying time!
  $result = db_query("
    SELECT
      filename AS real_filename, ID_ATTACH AS id_attach, attachmentType AS attachment_type, file_hash
    FROM {$db_prefix}attachments
    WHERE ID_ATTACH = $id_attach AND ID_MEMBER > 0 AND attachmentType = 0
    LIMIT 1", __FILE__, __LINE__);

  # Not doing this would save resources,
  # but it probably ought to be done.
  db_query("
    UPDATE LOW_PRIORITY {$db_prefix}attachments
    SET downloads = downloads + 1
    WHERE ID_ATTACH = $id_attach
    LIMIT 1", __FILE__, __LINE__);

  # Now get the information :D
  $file = mysql_fetch_assoc($result);

  $file['filename'] = getAttachmentFilename($file['real_filename'], $id_attach, false, $file['file_hash']);

  # ETag time? I think so!
  $file['etag'] = '"'. function_exists('md5_file') ? md5_file($file['filename']) : md5(file_get_contents($file['filename'])). '"';

  # Figure out the MIME type... (Not done in SMF 1.1.x)
  $size = @getimagesize($file['filename']);
  if(!empty($size))
  {
    $types = array(
				1 => 'gif',
				2 => 'jpeg',
				3 => 'png',
				5 => 'psd',
				6 => 'x-ms-bmp',
				7 => 'tiff',
				8 => 'tiff',
				9 => 'jpeg',
				14 => 'iff',
    );
  }

  # Let's save the MIME type. Then we can cache it!
	if(!empty($size['mime']) && !in_array($size[2], array(4, 13)))
    $file['mime_type'] = strtr($size['mime'], array('image/bmp' => 'image/x-ms-bmp'));
  elseif (isset($types[$size[2]]))
    $file['mime_type'] = 'image/'. $types[$size[2]];

  # Cache it... (Why do I randomly select a length at which to expire? Search around for RIP_JITTER :P)
  cache_put_data('avatar_lookup_id-'. $id_attach, $file, mt_rand(850, 900));
}

# File not exist? That does us no good!
if(!file_exists($file['filename']))
{
  # Yeah, it didn't exist.
  header('HTTP/1.0 404 File Not Found');

  die('Invalid avatar request.');
}

# You got it in your cache? Fine. Be that way.
if(!empty($_SERVER['HTTP_IF_MODIFIED_SINCE']))
{
  @list($since) = explode(';', $_SERVER['HTTP_IF_MODIFIED_SINCE']);
  if(strtotime($since) >= filemtime($file['filename']))
  {
    header('HTTP/1.1 304 Not Modified');
    exit;
  }
}

if(!empty($_SERVER['HTTP_IF_NONE_MATCH']) && strpos($_SERVER['HTTP_IF_NONE_MATCH'], $file['etag']) !== false)
{
  # Not modified!
  header('HTTP/1.1 304 Not Modified');
  exit;
}

# Now are headers, and we are good to go!
header('Expires: '. gmdate('D, d M Y H:i:s', time() + 31536000). ' GMT'); # Expire in a year. Hehe.
header('Last-Modified: '. gmdate('D, d M Y H:i:s', filemtime($file['filename'])). ' GMT');
header('Accept-Ranges: bytes');
header('Connection: close');
header('ETag: '. $file['etag']);
header('Content-Type: '. $file['mime_type']);

# Now output the file, and we can call it good!
$fp = fopen($file['filename'], 'rb');
while(!feof($fp))
  echo fread($fp, 8192);
fclose($fp);
exit;
?>